package tests

import (
  "testing"
  "context"
  "time"
  "github.com/stretchr/testify/assert"
  browser "github.com/chromedp/chromedp"
)

func Run(assert *assert.Assertions, ctx context.Context, actions ...browser.Action) {
  err := browser.Run(ctx, actions...)
  assert.NoError(err)
}

func Setup(timeout time.Duration) (context.Context, context.CancelFunc) {
  ctx, _ := browser.NewContext(context.Background())

  return context.WithTimeout(ctx, timeout * time.Second)
}

func TestStreamPage(t *testing.T) {
  assert := assert.New(t)

  ctx, cancel := Setup(20); defer cancel()

  var example string

  Run(assert, ctx,
          browser.Navigate(`http://127.0.0.1:5002`),
          browser.WaitVisible(`body > footer`),
          browser.Click(`#streams`, browser.NodeVisible),
          browser.Text(`#streams-title`, &example))

  assert.Equal(example, "Past Streams")
}
